#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>
int main(int argc, char *argv[]) {
        void *descriptor_bib; double (*cos)(double);

	if (argv[1]&&argv[2]) { // carga bib. dinámica especificada en argv[2]
        	if (!(descriptor_bib=dlopen(argv[2], RTLD_LAZY))) {
                	fprintf(stderr, "Error carga biblio: %s\n", dlerror());
                	return -1;
        	}
        	if (!(cos=dlsym(descriptor_bib, "cos"))) // Busca símbolo "cos"
                	fprintf(stderr, "Error: biblio no incluye cos\n");

		printf("cos(%lf) = %lf\n", atof(argv[1]), cos(atof(argv[1])));
		dlclose(descriptor_bib);
	}
	return 0;
}
