#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <ctype.h>
#include <string.h>


struct empleado {
	char nombre[32];
	int nhijos;
	// etc.
};

char *fich_plantilla ="plantilla.dat";

int main(int argc, char *argv[]) {
	int fd;
	struct empleado e;

        if (argc !=2) {
                fprintf(stderr, "Uso: %s nombre\n", argv[0]);
                return 1;
        }
        /* Abre el archivo */
	if ((fd=open(fich_plantilla, O_RDWR|O_CREAT, 0600))<0) {
                perror("No puede abrirse el archivo");
                return(1);
        }

        /* Busca el empleado */
	while (read(fd, &e, sizeof(e)))
		if (strcmp(e.nombre, argv[1])==0){
			e.nhijos++;
			lseek(fd, -sizeof(e), SEEK_CUR);
			write(fd, &e, sizeof(e));
			break;
		}


	return 0;
}
