#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <ctype.h>
#include <string.h>


struct empleado {
	char nombre[32];
	int nhijos;
	// etc.
};

char *fich_plantilla ="plantilla.dat";

int main(int argc, char *argv[]) {
	int fd;
	struct empleado e;

        if (argc < 3) {
                fprintf(stderr, "Uso: %s nombre nhijos...\n", argv[0]);
                return 1;
        }
        /* Abre el archivo */
	if ((fd=open(fich_plantilla, O_WRONLY|O_CREAT|O_APPEND, 0600))<0) {
                perror("No puede abrirse el archivo");
                return(1);
        }

        /* Incluye datos del nuevo empleado */
	strcpy(e.nombre, argv[1]);
	e.nhijos=atoi(argv[2]);
	if (write(fd, &e, sizeof(e))<0) {
                perror("No puede escribirse en el archivo");
                return(1);
        }

	return 0;
}
